package eu.eudat.data.query.items.table.project;

import eu.eudat.data.dao.criteria.ProjectCriteria;
import eu.eudat.data.entities.Project;
import eu.eudat.data.query.definition.Query;
import eu.eudat.data.query.definition.TableQuery;
import eu.eudat.queryable.QueryableList;

import java.util.UUID;

public class ProjectTableRequest extends TableQuery<ProjectCriteria,Project,UUID> {
    @Override
    public QueryableList<Project> applyCriteria() {
        QueryableList<Project> query = this.getQuery();
        if (this.getCriteria().getLike() != null && !this.getCriteria().getLike().isEmpty())
            query.where((builder, root) -> builder.or(
                    builder.like(builder.upper(root.get("label")), "%" + this.getCriteria().getLike().toUpperCase() + "%"),
                    builder.like(builder.upper(root.get("description")), "%" + this.getCriteria().getLike().toUpperCase() + "%")));
        if (this.getCriteria().getPeriodEnd() != null)
            query.where((builder, root) -> builder.lessThan(root.get("enddate"), this.getCriteria().getPeriodEnd()));
        if (this.getCriteria().getPeriodStart() != null)
            query.where((builder, root) -> builder.greaterThan(root.get("startdate"), this.getCriteria().getPeriodStart()));
        if (this.getCriteria().getReference() != null)
            query.where((builder, root) -> builder.equal(root.get("reference"), this.getCriteria().getReference()));
        query.where((builder, root) -> builder.notEqual(root.get("status"), Project.Status.DELETED.getValue()));
        return query;
    }

    @Override
    public QueryableList<Project> applyPaging(QueryableList<Project> items) {
        return null;
    }
}
