package eu.eudat.models.data.listingmodels;

import eu.eudat.data.entities.Dataset;
import eu.eudat.models.DataModel;
import eu.eudat.models.data.dataset.DataRepository;
import eu.eudat.models.data.dataset.Service;
import eu.eudat.logic.utilities.helpers.LabelBuilder;

import java.util.Date;
import java.util.stream.Collectors;


public class DatasetListingModel implements DataModel<Dataset, DatasetListingModel> {
    private String id;
    private String label;
    private String project;
    private String dmp;
    private String profile;
    private String dataRepositories;
    private String registries;
    private String services;
    private int status;
    private Date created;
    private String description;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getProject() {
        return project;
    }

    public void setProject(String project) {
        this.project = project;
    }

    public String getDmp() {
        return dmp;
    }

    public void setDmp(String dmp) {
        this.dmp = dmp;
    }

    public String getProfile() {
        return profile;
    }

    public void setProfile(String profile) {
        this.profile = profile;
    }

    public String getDataRepositories() {
        return dataRepositories;
    }

    public void setDataRepositories(String dataRepositories) {
        this.dataRepositories = dataRepositories;
    }

    public String getRegistries() {
        return registries;
    }

    public void setRegistries(String registries) {
        this.registries = registries;
    }

    public String getServices() {
        return services;
    }

    public void setServices(String services) {
        this.services = services;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public Date getCreated() {
        return created;
    }

    public void setCreated(Date created) {
        this.created = created;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public DatasetListingModel fromDataModel(Dataset entity) {
        this.id = entity.getId().toString();
        this.label = entity.getLabel();
        this.created = entity.getCreated();
        this.project = entity.getDmp().getProject().getLabel();
        this.dmp = entity.getDmp() != null ? entity.getDmp().getLabel() : "";
        this.profile = entity.getProfile() != null ? entity.getProfile().getLabel() : "";
        this.description = entity.getDescription();
        this.status = entity.getStatus();
        this.registries = LabelBuilder.getLabel(entity.getRegistries().stream().map(item -> new eu.eudat.models.data.dataset.Registry().fromDataModel(item)).collect(Collectors.toList()));
        this.dataRepositories = LabelBuilder.getLabel(entity.getDatasetDataRepositories().stream().map(item -> new DataRepository().fromDataModel(item.getDataRepository())).collect(Collectors.toList()));
        this.services = LabelBuilder.getLabel(entity.getServices().stream().map(item -> new Service().fromDataModel(item.getService())).collect(Collectors.toList()));
        return this;
    }

    @Override
    public Dataset toDataModel() {
        return null;
    }

    @Override
    public String getHint() {
        return "datasetListingModel";
    }
}
