import { BaseHttpService } from '../utilities/cite-http-service-module/base-http.service';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { TranslateLoader } from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import { SharedModule } from '../shared/shared.module';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';
import { AboutRoutes } from './about.routes';
import { AboutComponent } from './components/about.component';

@NgModule({
	imports: [
		CommonModule,
		FormsModule,
		SharedModule,
		HttpClientModule,
		AboutRoutes,
		TranslateModule.forRoot({
			loader: {
				provide: TranslateLoader,
				useFactory: HttpLoaderFactory,
				deps: [HttpClient]
			}
		}),
	],

	declarations: [
		AboutComponent
	],

	exports: [
		AboutComponent
	],
	providers: [
		BaseHttpService
	]
})

export class AboutModule {
	constructor(private translate: TranslateService) {
		translate.setDefaultLang('en');
		translate.use('en');
	}
}

export function HttpLoaderFactory(httpClient: HttpClient) {
	return new TranslateHttpLoader(httpClient, 'assets/lang/', '.json');
}
