import { Component, Inject, OnInit, ViewEncapsulation } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';
import { ActivatedRoute, Router } from '@angular/router';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
import { ExternalDatasetModel } from '../../../models/external-dataset/ExternalDatasetModel';
import { ExternalDatasetService } from '../../../services/external-dataset/external-dataset.service';

@Component({
	selector: 'app-externaldataset-referenced-model-helper',
	templateUrl: 'externaldataset-referenced-model-helper.component.html',
	styleUrls: ['./externaldataset-referenced-model-helper.component.scss'],
	encapsulation: ViewEncapsulation.None
})
export class ExternalDatasetReferencedModelHelperComponent extends BaseComponent implements OnInit {
	public formGroup: FormGroup;

	constructor(
		private externalDatasetService: ExternalDatasetService,
		private route: ActivatedRoute,
		public router: Router,
		public dialogRef: MatDialogRef<ExternalDatasetReferencedModelHelperComponent>,
		@Inject(MAT_DIALOG_DATA) public data: any
	) { super(); }

	ngOnInit(): void {
		const externalDatasetModel = new ExternalDatasetModel();
		this.formGroup = externalDatasetModel.buildForm();
	}


	send(value: any) {
		this.externalDatasetService.create(this.formGroup.value)
			.pipe(takeUntil(this._destroyed))
			.subscribe(
				(item) => this.dialogRef.close(item)
			);
	}
}
