import { Component, Inject, OnInit, ViewEncapsulation } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';
import { ActivatedRoute, Router } from '@angular/router';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
import { RegisterModel } from '../../../models/registers/RegisterModel';
import { RegistryService } from '../../../services/registries/registry.service';

@Component({
	selector: 'app-registry-referenced-model-helper',
	templateUrl: 'registry-referenced-model-helper.component.html',
	styleUrls: ['./registry-referenced-model-helper.component.scss'],
	encapsulation: ViewEncapsulation.None
})
export class RegistryReferencedModelHelperComponent extends BaseComponent implements OnInit {
	public formGroup: FormGroup;

	constructor(
		private registryService: RegistryService,
		private route: ActivatedRoute,
		public router: Router,
		public dialogRef: MatDialogRef<RegistryReferencedModelHelperComponent>,
		@Inject(MAT_DIALOG_DATA) public data: any
	) { super(); }

	ngOnInit(): void {
		const registryModel = new RegisterModel();
		this.formGroup = registryModel.buildForm();
	}


	send(value: any) {
		this.registryService.create(this.formGroup.value)
			.pipe(takeUntil(this._destroyed))
			.subscribe(
				(item) => this.dialogRef.close(item)
			);
	}
}
