import { DatasetWizardComponent } from './dataset-wizard/dataset-wizard.component';
import { DatasetListingComponent } from './listing/dataset-listing.component';
import { RouterModule, Routes } from '@angular/router';
import { AuthGuard } from '../shared/guards/auth.guard';
import { DatasetPublicListingComponent } from './dataset-public/dataset-public-listing.component';

export const DatasetRoutes: Routes = [
	{
		path: 'new/:dmpId',
		component: DatasetWizardComponent,
		canActivate: [AuthGuard],
		data: {
			breadcrumb: true
		},
	},
	{
		path: 'edit/:id',
		component: DatasetWizardComponent,
		canActivate: [AuthGuard],
		data: {
			breadcrumb: true,
			public: false
		},
	},
	{
		path: 'publicEdit/:id',
		component: DatasetWizardComponent,
		//canActivate: [AuthGuard],
		data: {
			public: true
		}
	},
	{
		path: 'new',
		component: DatasetWizardComponent,
		canActivate: [AuthGuard],
		data: {
			breadcrumb: true
		},
	},
	{
		path: '',
		component: DatasetListingComponent,
		//canActivate: [AuthGuard],
		data: {
			breadcrumb: true
		},
	},
	{
		path: 'public',
		component: DatasetPublicListingComponent,
		data: {
			breadcrumb: false
		}
	},
	{
		path: 'dmp/:dmpId',
		component: DatasetListingComponent,
		//canActivate: [AuthGuard],
		data: {
			breadcrumb: true
		},
	}
];
