import { JsonSerializer } from '../../utilities/JsonSerializer';
import { DataField } from './DataField';
import { ListingItem } from '../common/ListingItem';
import { FormGroup } from '@angular/forms';

export class RadioBoxData extends DataField<RadioBoxData> {
	public options: Array<ListingItem>;

	buildForm(): FormGroup {
		const formGroup = this.formBuilder.group({
			label: [this.label]
		});
		const optionsFormArray = new Array<FormGroup>();
		if (this.options) {
			this.options.forEach(item => {
				const form: FormGroup = item.buildForm();
				optionsFormArray.push(form);
			});
		}
		formGroup.addControl('options', this.formBuilder.array(optionsFormArray));
		return formGroup;
	}

	fromJSONObject(item: any): RadioBoxData {
		this.options = JsonSerializer.fromJSONArray(item.options, ListingItem);
		this.label = item.label;
		return this;
	}
}
