﻿import { BaseModel } from '../BaseModel';
import { Rule } from './Rule';
import { FormGenerator } from '../interfaces/FormGenerator';
import { FormGroup } from '@angular/forms';
import { Serializable } from '../interfaces/Serializable';
import { JsonSerializer } from '../../utilities/JsonSerializer';

export class Visibility extends BaseModel implements Serializable<Visibility>, FormGenerator<FormGroup> {
	public rules: Array<Rule> = new Array<Rule>();
	public style: string;

	fromJSONObject(item: any): Visibility {
		this.rules = JsonSerializer.fromJSONArray(item.rules, Rule);
		this.style = item.style;

		return this;
	}

	buildForm(): FormGroup {
		const formGroup = this.formBuilder.group({
			style: [this.style]
		});

		const rulesFormArray = new Array<FormGroup>();
		if (this.rules) {
			this.rules.forEach(rule => {
				const form: FormGroup = rule.buildForm();
				rulesFormArray.push(form);
			});
		}

		formGroup.addControl('rules', this.formBuilder.array(rulesFormArray));

		return formGroup;
	}

}
