import { HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from '../../../environments/environment';
import { DataRepositoryModel } from '../../models/dataRepositories/DataRepositoryModel';
import { BaseHttpService } from '../../utilities/cite-http-service-module/base-http.service';

@Injectable()
export class DataRepositoryService {

	private actionUrl: string;
	private headers: HttpHeaders;

	constructor(private http: BaseHttpService) {

		this.actionUrl = environment.Server + 'datarepos/';

		this.headers = new HttpHeaders();
		this.headers = this.headers.set('Content-Type', 'application/json');
		this.headers = this.headers.set('Accept', 'application/json');
	}

	create(dataRepoModel: DataRepositoryModel): Observable<DataRepositoryModel> {
		return this.http.post<DataRepositoryModel>(this.actionUrl + 'create', dataRepoModel, { headers: this.headers });
	}

}
