import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from '../../environments/environment';
import { AutocompleteLookupItem } from '../models/auto-complete/AutocompleteLookupItem';
import { RequestItem } from '../models/criteria/RequestItem';
import { DatasetProfileAdmin } from '../services/datasetProfileAdmin/datasetProfileAfmin.service';

@Injectable()
export class DatasetProfileService {

	private actionUrl: string;
	private headers: HttpHeaders;

	constructor(private httpClient: HttpClient, private datasetProfileAdmin: DatasetProfileAdmin) {
		this.actionUrl = environment.Server + 'datasetwizard/';

		this.headers = new HttpHeaders();
		this.headers = this.headers.set('Content-Type', 'application/json');
		this.headers = this.headers.set('Accept', 'application/json');
	}

	getDatasetProfileById(datasetProfileID) {
		return this.datasetProfileAdmin.getDatasetProfileById(datasetProfileID);
	}

	queryAutocomplete(lookUpItem: RequestItem<AutocompleteLookupItem>): Observable<any> {
		return this.httpClient.post(environment.Server + 'search/autocomplete', lookUpItem);
	}

}
