import { HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from '../../../environments/environment';
import { ExternalSourcesConfiguration } from '../../models/external-sources/ExternalSourcesConfiguration';
import { BaseHttpService } from '../../utilities/cite-http-service-module/base-http.service';


@Injectable()
export class ExternalSourcesConfigurationService {

	private actionUrl: string;
	private headers: HttpHeaders;

	constructor(private http: BaseHttpService) {

		this.actionUrl = environment.Server + 'common/';

		this.headers = new HttpHeaders();
		this.headers = this.headers.set('Content-Type', 'application/json');
		this.headers = this.headers.set('Accept', 'application/json');
	}

	public getExternalSourcesConfiguration(): Observable<ExternalSourcesConfiguration> {
		return this.http.get<ExternalSourcesConfiguration>(this.actionUrl + 'externalSourcesConfiguration', { headers: this.headers });
	}

}
