import { TranslateService } from '@ngx-translate/core';
import { Component, OnInit, Input } from '@angular/core';
import { BaseCriteriaComponent } from '../base/base-criteria.component';
import { DatasetProfileCriteria } from '../../../../models/criteria/dataset-profile/DatasetProfileCriteria';
import { FormBuilder } from '@angular/forms';

@Component({
	selector: 'app-dataset-profile-criteria-component',
	templateUrl: './dataset-profile.component.html',
	styleUrls: ['./dataset-profile.component.scss'],
})

export class DatasetProfileCriteriaComponent extends BaseCriteriaComponent implements OnInit {

	public criteria: DatasetProfileCriteria = new DatasetProfileCriteria();

	constructor(
		public language: TranslateService,
		public formBuilder: FormBuilder
	) {
		super(new DatasetProfileCriteria());
	}

	ngOnInit() {
		super.ngOnInit();
		if (this.criteria == null) { this.criteria = new DatasetProfileCriteria(); }
	}

	setCriteria(criteria: DatasetProfileCriteria): void {
		this.criteria = criteria;
	}

	onCallbackError(error: any) {
		this.setErrorModel(error.error);
	}

	controlModified(): void {
		this.clearErrorModel();
		if (this.refreshCallback != null &&
			(this.criteria.like == null || this.criteria.like.length === 0 || this.criteria.like.length > 2)
		) {
			this.refreshCallback();
		}
	}
}
