import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { Placeholder } from '@angular/compiler/src/i18n/i18n_ast';
import { FormGroup, FormControl } from '@angular/forms';
import { AutoCompleteConfiguration } from '../../auto-complete/AutoCompleteConfiguration';

@Component({
	selector: 'app-external-item',
	templateUrl: './external-item.component.html',
	styleUrls: ['./external-item.component.scss']
})
export class ExternalItemComponent implements OnInit {

	@Input()
	public placeholder: string;

	@Input()
	public formGroup: FormGroup;

	@Input()
	public autoCompleteConfiguration: AutoCompleteConfiguration;

	@Input()
	public displayFunction: Function;

	@Input()
	public subtitleFunction: Function;

	@Input()
	public disabled = false;

	@Input()
	public titleKey: string;

	@Output()
	public onItemChange = new EventEmitter<any>();

	@Input()
	public formCtrl: FormControl;

	ngOnInit() {
	}

	onItemChangeFunc(event) {
		this.onItemChange.emit(event);
	}
}
