import { Component, Inject } from '@angular/core';
import { MAT_SNACK_BAR_DATA } from '@angular/material';
import { TranslateService } from '@ngx-translate/core';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
@Component({
	selector: 'app-snack-bar-notification',
	templateUrl: 'snack-bar-notification.component.html'
})

export class SnackBarNotificationComponent extends BaseComponent {
	message: string;
	constructor(@Inject(MAT_SNACK_BAR_DATA) public data: any) {
		super();
		this.parseMessage(data.message, data.language);
	}

	parseMessage(message: any, language: TranslateService): void {
		if (language) {
			language.get(message)
				.pipe(takeUntil(this._destroyed))
				.subscribe((value: string) => {
					this.message = value;
				});
		} else { this.message = message; }
	}
}
