import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
import { LoginService } from '../../utilties/login-service';

@Component({
	selector: 'app-b2access-login',
	templateUrl: './b2access-login.component.html',
})
export class B2AccessLoginComponent extends BaseComponent implements OnInit {

	constructor(
		private router: Router,
		private route: ActivatedRoute,
		private loginService: LoginService
	) {
		super();
	}

	ngOnInit(): void {
		this.route.queryParams
			.pipe(takeUntil(this._destroyed))
			.subscribe((data: any) => {
				if (!data['code']) { this.loginService.b2AccessGetAuthCode(); } else { this.loginService.b2AccessLogin(data['code']); }
			});
	}

}
