import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
import { LoginService } from '../../utilties/login-service';

@Component({
	selector: 'app-linkedin-login',
	templateUrl: './linkedin-login.component.html',
})
export class LinkedInLoginComponent extends BaseComponent implements OnInit {

	constructor(
		private router: Router,
		private route: ActivatedRoute,
		private loginService: LoginService
	) {
		super();
	}

	ngOnInit(): void {
		this.route.queryParams
			.pipe(takeUntil(this._destroyed))
			.subscribe((data: any) => {
				if (!data['code']) { this.loginService.linkedinAuthorize(); } else { this.loginService.linkedInloginUser(data['code']); }
			});
	}

}
