import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../core/common/base/base.component';
import { LoginService } from '../../utilties/login-service';
@Component({
	selector: 'app-twitter-login',
	templateUrl: './twitter-login.component.html',
})
export class TwitterLoginComponent extends BaseComponent implements OnInit {
	constructor(
		private router: Router,
		private route: ActivatedRoute,
		private loginService: LoginService
	) {
		super();
	}

	ngOnInit(): void {
		this.route.queryParams
			.pipe(takeUntil(this._destroyed))
			.subscribe((data: any) => {
				if (!data['oauth_token'] && !data['oauth_verifier']) { this.loginService.twitterAuthorize(); } else { this.loginService.twitterLogin(data['oauth_token'], data['oauth_verifier']); }
			});
	}

}
