import { CommonModule } from '@angular/common';
import { NgModule, ModuleWithProviders } from '@angular/core';
import { AuthService } from '../../services/auth/auth.service';
import { BaseHttpService } from './base-http.service';
import { TranslateService, TranslateModule, TranslateLoader } from '@ngx-translate/core';
import { HttpLoaderFactory } from '../../projects/projects.module';
import { HttpClient, HttpClientModule } from '@angular/common/http';

@NgModule({
	imports: [
		CommonModule,
		HttpClientModule
	]
})
export class BaseHttpModule {
	static forRoot(): ModuleWithProviders {
		return {
			ngModule: BaseHttpModule,
			providers: [
				AuthService,
				BaseHttpService
			]
		};
	}
}
