// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
	production: false,
	Server: 'http://localhost:8080/api/',
	App: 'http://localhost:4200/',
	HelpService: {
		Enabled: false,
		Url: 'localhost:5000/',
	},
	defaultCulture: 'en-US',
	loginProviders: {
		facebookConfiguration: { clientId: '' },
		googleConfiguration: { clientId: '' },
		linkedInConfiguration: {
			clientId: '',
			oauthUrl: 'https://www.linkedin.com/oauth/v2/authorization',
			redirectUri: 'http://localhost:4200/login/linkedin',
			accessTokenUri: 'https://www.linkedin.com/oauth/v2/accessToken',
			clientSecret: ''
		},
		twitterConfiguration: {
			clientId: '',
			oauthUrl: 'https://api.twitter.com/oauth/authenticate'
		},
		b2accessConfiguration: {
			clientId: 'eudatdmptool',
			oauthUrl: 'https://b2access-integration.fz-juelich.de:443/oauth2-as/oauth2-authz',
			redirectUri: 'http://opendmp.eu/api/oauth/authorized/b2access'
		}
	}
};
